Interface IFrameXform
- Namespace
- ESRI.ArcGIS.DatasourcesRaster
- Assembly
- ESRI.Server.DatasourcesRaster.dll
Provides access to members that control a standard frame camera transform.
[InterfaceType(ComInterfaceType.InterfaceIsIUnknown)]
[Guid("68F50E4B-6E2D-4950-BD52-D9646ACC8A97")]
public interface IFrameXform : IGeodataXform
Remarks
Use this interface to set and query parameters associated with a standard frame camera. Many of the parameters are required, and there are multiple ways to set some of these. See the documentation for each parameter for more details.
The required parameters are:
Interior orientation
Principal point
Focal length
Perspective center
Perspective matrix or perspective angles
Average Z or a DEM
Konrady coefficients if radial distortion correction is needed
Properties
ApplyCurvatureAndRefraction
Indicates if the adjustment of earth curvature and refraction is applied.
bool ApplyCurvatureAndRefraction { get; set; }
Property Value
Remarks
Optional parameter indicating whether the earth curvature and atmospheric distortion correction should be applied. By default it is not. It is primarily used for high altitude aerial photography, as the effect is minimal in most aerial surveys.
AverageZ
The average Z in meters.
double AverageZ { get; set; }
Property Value
Remarks
When performing ortho-rectification, a source of elevation data is required. This is often a digital elevation model (DEM) dataset. If a DEM is not available, the average elevation in the area of interest must be set for best results.
Domains
IGeometryCollection Domains { get; }
Property Value
EarthRadius
The earth radius in meters.
double EarthRadius { get; set; }
Property Value
EnableKonrady
Indicates if the Konrady adjustment to be applied.
bool EnableKonrady { get; set; }
Property Value
Remarks
This parameter controls whether radial distortion correction is performed or not. If the corrections were applied during post-processing of the images, set this value to false. Otherwise, provide the Konrady coefficients. Be sure to set the correct Konrady type (ESRI or USGS) that corresponds to the coefficients.
FocalLength
The focal length in micron.
double FocalLength { get; set; }
Property Value
InteriorOrientation
The interior orientation as an affine transformation.
IGeodataXform InteriorOrientation { get; set; }
Property Value
IsIdentity
bool IsIdentity { get; }
Property Value
KonradyParameters
The Konrady adjustment parameters.
object KonradyParameters { get; set; }
Property Value
Remarks
Konrady coefficients are used to correct radial distortions in standard frame cameras. Three double precision values are stored and used when displaying the imagery. See the ESRIRasterKonradyType enumeration values to see how these coefficients are applied.
KonradyType
The Konrady calculation method.
esriRasterKonradyType KonradyType { get; set; }
Property Value
LSR
The LSR-To-USR conversion.
IGeodataXform LSR { get; set; }
Property Value
PerspectiveCenter
The sensor position.
IPoint PerspectiveCenter { get; set; }
Property Value
PerspectiveMatrix
The specified sensor orientation as an orthogonal rotation matrix.
object PerspectiveMatrix { get; set; }
Property Value
Remarks
The perspective matrix is a 3x3 rotation matrix that adjusts the imagery based on the three perspective angles associated with an image frame. The three angles represent the roll, pitch and yaw of the aircraft (omega, phi, kappa) when the exposure was taken.
There are two ways to set the perspective matrix: put_PerspectiveMatrix( ) and PutPerspectiveAngles( ). Both methods populate the 3x3 rotation matrix. The choice of which to use is largely based on what information is available in the aerial photography project file.
PerspectivePolarity
The sensor polarity.
int PerspectivePolarity { get; set; }
Property Value
Remarks
An optional parameter that defines the direction of the Z axis. The default value is -1, and should only be changed for sensor that use that convention.
PrincipalPoint
The film principal point.
IPoint PrincipalPoint { get; set; }
Property Value
Residuals
The residuals for distortion table points.
IDoubleArray Residuals { get; }
Property Value
Remarks
After using the distortion table to calculate the Konrady coefficients, it is important to check the residuals to detect if any anomalies, for instance an error when inputing the data values. Under normal circumstances, the residuals should be just a few microns. Larger residuals could indicate a problem with the data points.
SpatialReference
ISpatialReference SpatialReference { get; set; }
Property Value
Methods
GetDistortionTable(out IDoubleArray, out IDoubleArray)
The distortion tables.
void GetDistortionTable(out IDoubleArray ppDistanceInMillimeters, out IDoubleArray ppDistortionInMicrons)
Parameters
ppDistanceInMillimetersIDoubleArrayppDistortionInMicronsIDoubleArray
PutDistortionTable(IDoubleArray, IDoubleArray)
The distortion tables to calculate Konrady coefficients and residuals.
void PutDistortionTable(IDoubleArray pDistanceInMillimeters, IDoubleArray pDistortionInMicrons)
Parameters
pDistanceInMillimetersIDoubleArraypDistortionInMicronsIDoubleArray
Remarks
An alternative to put_KonradyParameters, this method allows the use of the distortion tables contained in the camera calibration report to calculate the Konrady coefficients. It is critical to ensure that the units are correct for the two arrays that are passed in. The first array is the radial distance in mm, while the second array is the distortion errors in microns. Either ESRI or USGS conventions can be used to calculate the coefficients. See the ESRIRasterKonradyType enumeration for more details.
PutInteriorOrientationParameters(esriTransformDirection, object)
Puts the interior orientation parameters.
void PutInteriorOrientationParameters(esriTransformDirection direction, object Parameters)
Parameters
directionesriTransformDirectionParametersobject
Remarks
See putref_InteriorOrientation for more details.
PutPerspectiveAngles(double, double, double, bool)
Puts the sensor exterior orientation as a set of rotation angles in degrees.
void PutPerspectiveAngles(double omega, double phi, double kappa, bool clockwise)
Parameters
Remarks
An alternative to put_PerspectiveMatrix( ) for establishing the rotation matrix.
QueryKonradyParameters(ref double)
Queries the Konrady adjustment parameterrs.
void QueryKonradyParameters(ref double pK)
Parameters
pKdouble
QueryPerspectiveAngles(out double, out double, out double, out bool)
Queries the sensor exterior orientation as a set of rotation angles in degrees.
void QueryPerspectiveAngles(out double pOmega, out double pPhi, out double pKappa, out bool pClockwise)
Parameters
QueryPerspectiveMatrix(ref double)
Queries the perspective matrix.
void QueryPerspectiveMatrix(ref double pMatrix)
Parameters
pMatrixdouble
Transform(esriTransformDirection, int, ref WKSPoint)
void Transform(esriTransformDirection Direction, int npoints, ref WKSPoint points)
Parameters
DirectionesriTransformDirectionnpointsintpointsWKSPoint
TransformCellsize(esriTransformDirection, ref double, ref double, IEnvelope)
void TransformCellsize(esriTransformDirection Direction, ref double dx, ref double dy, IEnvelope AreaOfInterest)
Parameters
DirectionesriTransformDirectiondxdoubledydoubleAreaOfInterestIEnvelope
TransformExtent(esriTransformDirection, IEnvelope)
void TransformExtent(esriTransformDirection Direction, IEnvelope Extent)
Parameters
DirectionesriTransformDirectionExtentIEnvelope
TransformPoints(esriTransformDirection, IPointCollection)
void TransformPoints(esriTransformDirection Direction, IPointCollection points)
Parameters
DirectionesriTransformDirectionpointsIPointCollection